<?php
namespace Teknisa\MAN\Controllers;

use \Teknisa\Libs\Utilities\Environment;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;

class FilialFilioperComGrupo extends \Teknisa\MAN\Controllers\TeknisaCrud {

    protected $dataSourceName = "filial_filioper_grupfili";
    protected $parameterBagColumns = ["NRORG", "CDOPERADOR", "CDGRUPFILI", 'PERFIL'];
    
    public function __construct($util, $environment, $crudService, $parameterBag) {
        $this->environment = $environment;
        $this->util = $util;
        parent::__construct($crudService, $parameterBag);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $filterCriteria = $request->getFilterCriteria();
        $conditions = $filterCriteria->getConditions();
        $operadorCondition = array_filter($conditions, function($item) {
            return strtoupper($item['columnName']) == 'CDOPERADOR';
        });
        if ($operadorCondition == null) {
            $filterCriteria->addCondition("CDOPERADOR", "OPERADOR_LOGADO");
        }
        if($this->environment->getIdUtlPerfilFilial() == 'S'){
            $rows['NRPERFIL'] = $this->environment->getNrPerfil();
            $filterCriteria->addCondition("PERFIL", $rows['NRPERFIL']);
            $this->dataSourceName = 'filial_filioper_grupfili_perfil' ;
        } else {
            $this->dataSourceName = 'filial_filioper_grupfili' ;
        }
        parent::find($request, $response);
    }
}
